#fonction de norme
n01<-function(vecteur,plage)
{ (vecteur-range(plage)[1])/(range(plage)[2]-range(plage)[1]) }
#
#fonction de transfert 0-1 vers min-max
bru<-function(v01,plage)
{ v01*(range(plage)[2]-range(plage)[1])+range(plage)[1] }
#



conso<-read.csv("consotot.csv",sep=",")
tmoy<-read.csv("moygre.csv",sep=",")
tmes<-read.csv("meteotot.csv",sep=",")

tmo=NULL
tme=NULL
for(i in 1:nrow(conso))
{
  deb<-conso$jsep[i]-conso$nbj[i]
  fin<-conso$jsep[i]
  tmoy_filtre=tmoy[((tmoy$jsep>=deb)&(tmoy$jsep<fin)),]
  moy<-mean(tmoy_filtre$moy)
  tmo=c(tmo,moy)
  saison=conso$saison[i]
  tmes_filtre=tmes[((tmes$jsep>=deb)&(tmes$jsep<fin)&(tmes$saison==saison)),]
  mes<-mean(tmes_filtre$tmoy)
  tme=c(tme,mes)  
}
conso = data.frame(conso,tmoy=tmo,tmes=tme)


write.table(conso, file = "out.csv", append = FALSE, sep = ",")

dd<-conso$date
dd <- strptime(dd, "%d/%m/%Y")
conso = subset(conso, select = - c(date))
conso = data.frame(date=dd,conso) #dates en format utilisable
rm(dd)

conso1<-conso[(conso$saison==1),]
conso2<-conso[(conso$saison==2),]
conso3<-conso[(conso$saison==3),]
conso4<-conso[(conso$saison==4),]

########## graphique
legtex=c("anne 1","anne 2","anne 3","anne 4")
couleurs=c("black","blue","green","red")
marques=c(0,1,2,3)
ligpo="p"
plot(x=NULL,y=NULL,xlim = c(-10,30), ylim = c(0,100),xlab="C",ylab="kWh/j")
grid(col = "brown")
title(main="Consommation en fonction de la temprature")
legend("topright",legtex,col=couleurs,pch=marques)
points(type=ligpo,conso1$tmes,conso1$kWh_j,col=couleurs[1],pch=marques[1])
points(type=ligpo,conso2$tmes,conso2$kWh_j,col=couleurs[2],pch=marques[2])
points(type=ligpo,conso3$tmes,conso3$kWh_j,col=couleurs[3],pch=marques[3])
points(type=ligpo,conso4$tmes,conso4$kWh_j,col=couleurs[4],pch=marques[4])
##########

library("AMORE")
nneuro1  <- 5
nneuro2  <- 3
nshows  <- 20000
n <- length(conso$kWh_j)
Psnorm<-n01(Ps,Ps)
Tenorm  <- n01(Te,Te)


kwhj<-n01(conso$kWh_j,conso$kWh_j)
po<-n01(conso$poele,conso$poele)
surc<-n01(conso$surconso,conso$surconso)
surf<-n01(conso$surface,conso$surface)
tmes<-n01(conso$tmes,conso$tmes)
entrees  <- matrix(c(po,surc,surf,tmes),ncol=4,nrow=n)
NN<-newff(n.neurons=c(4,nneuro1,nneuro2,1),learning.rate.global=1e-2,momentum.global=0.5,error.criterium="LMS",Stao=NA,hidden.layer="sigmoid",output.layer="tansig",method="ADAPTgdwm")
result<-train(NN,entrees,kwhj,Pval=NULL, Tval=NULL,error.criterium="LMS",report=TRUE,show.step=1,n.shows=nshows)
plot(1:length(result$Merror[,1]),result$Merror[,1],col="blue")

kwhj_sim<-sim.MLPnet(result$net,entrees)
kwhj_bru<- bru(kwhj_sim,conso$kWh_j)
plot(kwhj_bru)
points(conso$kWh_j,col="blue")
Ecart <- abs((kwhj_bru-conso$kWh_j)/conso$kWh_j)
plot(conso$tmes,Ecart)

param<-read.csv("param.csv",sep=",")
np<-length(param$tmes)
po2<-n01(param$poele,conso$poele)
surc2<-n01(param$surconso,conso$surconso)
surf2<-n01(param$surface,conso$surface)
tmes2<-n01(param$tmes,conso$tmes)
entrees2  <- matrix(c(po2,surc2,surf2,tmes2),ncol=4,nrow=np)

kwhj_sim2<-sim.MLPnet(result$net,entrees2)
kwhj_bru2<- bru(kwhj_sim2,conso$kWh_j)

write(kwhj_bru2, file = "res_param.csv",ncolumns = 1, append = FALSE, sep = ",")

########## graphique
legtex=c("anne 1","anne 2","anne 3","anne 4")
couleurs=c("black","blue","green","red")
marques=c(0,1,2,3)
ligpo="b"
plot(x=NULL,y=NULL,xlim = c(0,1), ylim = c(0,100),xlab="Utilisation du poele (0-1)",ylab="kWh/j")
grid(col = "brown")
title(main="Prdiction de consommation et usage du poele  bois")
#legend("topright",legtex,col=couleurs,pch=marques)
points(type=ligpo,param$poele[1:6],kwhj_bru2[1:6],col=couleurs[1],pch=marques[1])
#points(type=ligpo,conso2$tmes,conso2$kWh_j,col=couleurs[2],pch=marques[2])
#points(type=ligpo,conso3$tmes,conso3$kWh_j,col=couleurs[3],pch=marques[3])
#points(type=ligpo,conso4$tmes,conso4$kWh_j,col=couleurs[4],pch=marques[4])
#########

########## graphique
legtex=c("anne 1","anne 2","anne 3","anne 4")
couleurs=c("black","blue","green","red")
marques=c(0,1,2,3)
ligpo="b"
plot(x=NULL,y=NULL,xlim = c(-1,1), ylim = c(0,100),xlab="Surconso (-1  1)",ylab="kWh/j")
grid(col = "brown")
title(main="Sur ou sous consommation prdite (vacances, invits...)")
#legend("topright",legtex,col=couleurs,pch=marques)
points(type=ligpo,param$surconso[7:11],kwhj_bru2[7:11],col=couleurs[1],pch=marques[1])
#points(type=ligpo,conso2$tmes,conso2$kWh_j,col=couleurs[2],pch=marques[2])
#points(type=ligpo,conso3$tmes,conso3$kWh_j,col=couleurs[3],pch=marques[3])
#points(type=ligpo,conso4$tmes,conso4$kWh_j,col=couleurs[4],pch=marques[4])
##########

########## graphique
legtex=c("anne 1","anne 2","anne 3","anne 4")
couleurs=c("black","blue","green","red")
marques=c(0,1,2,3)
ligpo="b"
plot(x=NULL,y=NULL,xlim = c(60,140), ylim = c(0,100),xlab="m",ylab="kWh/j")
grid(col = "brown")
title(main="Consommation prdite en fonction de la surface")
#legend("topright",legtex,col=couleurs,pch=marques)
points(type=ligpo,param$surface[12:16],kwhj_bru2[12:16],col=couleurs[1],pch=marques[1])
#points(type=ligpo,conso2$tmes,conso2$kWh_j,col=couleurs[2],pch=marques[2])
#points(type=ligpo,conso3$tmes,conso3$kWh_j,col=couleurs[3],pch=marques[3])
#points(type=ligpo,conso4$tmes,conso4$kWh_j,col=couleurs[4],pch=marques[4])
##########

########## graphique
legtex=c("anne 1","anne 2","anne 3","anne 4")
couleurs=c("black","blue","green","red")
marques=c(0,1,2,3)
ligpo="b"
plot(x=NULL,y=NULL,xlim = c(-10,40), ylim = c(0,100),xlab="C",ylab="kWh/j")
grid(col = "brown")
title(main="Consommation prdite en fonction de la temprature")
#legend("topright",legtex,col=couleurs,pch=marques)
points(type=ligpo,param$tmes[17:27],kwhj_bru2[17:27],col=couleurs[1],pch=marques[1])
#points(type=ligpo,conso2$tmes,conso2$kWh_j,col=couleurs[2],pch=marques[2])
#points(type=ligpo,conso3$tmes,conso3$kWh_j,col=couleurs[3],pch=marques[3])
#points(type=ligpo,conso4$tmes,conso4$kWh_j,col=couleurs[4],pch=marques[4])
##########

########## graphique
legtex=c("Sans poele","Avec Poele")
couleurs=c("black","blue")
marques=c(0,1)
ligpo="p"
plot(x=NULL,y=NULL,xlim = c(0,366), ylim = c(0,100),xlab="jour",ylab="kWh/j")
grid(col = "brown")
title(main="Consommation annuelle sur moyenne de temprature")
legend("topright",legtex,col=couleurs,pch=marques)
points(type=ligpo,kwhj_bru2[28:394],col=couleurs[1],pch=marques[1])
points(type=ligpo,kwhj_bru2[395:759],col=couleurs[2],pch=marques[2])
#points(type=ligpo,conso3$tmes,conso3$kWh_j,col=couleurs[3],pch=marques[3])
#points(type=ligpo,conso4$tmes,conso4$kWh_j,col=couleurs[4],pch=marques[4])
##########

consomoy<-sum(kwhj_bru2[28:394])
consomoy_poele<-sum(kwhj_bru2[395:759])

#plot(type="h",c(consomoy,consomoy_poele),xlim=c(0,3),ylim = c(0,10000),ylab="kWh",col="blue")
#title(main="Consommation totale moyenne avec ou sans poele")

